//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fswrite.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"




// WRITE DATA TO A FILE

int FSWrite(char *buffer,int nbytes,FS_FILE *file)
{


if(!FSystem.Init) return FS_ERROR;

if(!file) return FS_ERROR;

if(!(file->Mode&FSMODE_WRITE)) return FS_ERROR;	// WRITE NOT ALLOWED
if(file->Attr&FSATTR_RDONLY) return FS_ERROR;

if(file->Mode&FSMODE_APPEND) file->CurrentOffset=file->FileSize;		// ONLY AT THE END OF FILE

// CHANGE THIS WITH BUFFERED VERSION WHEN AVAILABLE
nbytes=FSWriteLL(buffer,nbytes,file,FSystem.Volumes[file->Volume]);

if(!(file->Mode&FSMODE_MODIFY)) {
file->FileSize=file->CurrentOffset;		// TRUNCATE FILE
}

return nbytes;
}
