//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_poke.c 393 2007-03-04 23:17:29Z ingo $

#include <hpgcc3.h>
#include <master_globals.h>
extern unsigned int sat3_s2a(SAT_OBJECT sat_addr);

void sat3_poke(SAT_OBJECT sataddr,unsigned val,int nibbles)
{
    
    // GENERAL POKE ROUTINE, UP TO 8 NIBBLES
    

    LONGLONG *ptr=(LONGLONG *)(sat3_s2a(sataddr)&0xfffffffc);

    ULONGLONG lval,mask2;
    unsigned int mask;
    int rot=(sataddr&7)<<2;
    
    lval=*ptr;
    mask=1<<(nibbles<<2);
    mask--;
    val&=mask;
    mask2=((ULONGLONG)mask)<<rot;
    mask2=-mask2-1;
    *ptr=(((ULONGLONG)val)<<rot)|(lval&mask2);

}
