//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// $Id: strok.c 514 2007-11-18 03:11:26Z ingo $

// ROMLIB CHECKED
// < ibl ; 2006-11-30 >

#include <kos.h>
#include <string.h>
#include <master_globals.h>


char *strtok_r(char *s, const char *sep, char **lasts)
{
    char *sbegin, *send;
    sbegin = s ? s : *lasts;
    sbegin += strspn(sbegin, sep);
    if (*sbegin == '\0') {
        *lasts = "";
        return NULL;
    }
    send = strpbrk(sbegin, sep);
    if (*send != '\0')
        *send++ = '\0';
    *lasts = send;
    return sbegin;
}


char *strtok(char *s1, const char *s2)
{
    //static char *ssave = "";
    // static char replaced with master globals member '__strtok_save'
    
    // < ibl ; 2006-11-30 >
    
    return strtok_r(s1, s2, &(__mg->__strtok_save));
}
