//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <sys.h>
#include <stdlib.h>
#include <stdio.h>

#include <hpgcc_config.h>
#include <master_globals.h>
#include <system_globals.h>


// MASSIVE GLOBAL REMOVAL BY CLAUDIO

/*

// WARNING: DO NOT CHANGE ORDER OF THIS GLOBALS AND ONLY ADD GLOBALS
// AT THE BEGINNING OF THIS FILE, *NEVER* AT THE END (REVERSE ORDER)

// *****************************
// MATH FUNCTIONS STATE
// *****************************

// < ibl ; 2006-04-03 >

// gauss()
int __gauss_have_next_gaussian __attribute__ ((section(".romglobals"))) = 0;
double __gauss_next_gaussian __attribute__ ((section(".romglobals"))) = 0.0;

// *****************************
// RANDOM NUMBER GENERATOR
// *****************************

// < ibl ; 2006-04-03 >
unsigned long long __mwc_w __attribute__ ((section(".romglobals"))) = 0LL;




// *****************************
// STDIO AND SCREEN-RELATED GLOBALS
// *****************************


int __scr_h __attribute__((section(".romglobals"))) = 13,
	__scr_w __attribute__((section(".romglobals")))= 33;
int __pos_x __attribute__((section(".romglobals")))=0,
	__pos_y __attribute__((section(".romglobals")))=0,
	__ch_w __attribute__((section(".romglobals")))=4,
	__ch_h __attribute__((section(".romglobals")))=6;
char *__decimal_separator __attribute__((section(".romglobals"))) =".";
int __decimal_digits __attribute__((section(".romglobals")))=6;
int __auto_cr __attribute__((section(".romglobals")))=1;

unsigned int    __display_buf __attribute__((section(".romglobals")))=0;

extern int putchar_console(int);
extern int putcon_stdscreen(int);

int (*__putchar_hook)(int) __attribute__((section(".romglobals")))= putchar_console;
void (*__putcon_hook)(int) __attribute__((section(".romglobals")))= putcon_stdscreen;



// *****************************
// HEAP MANAGEMENT
// *****************************


char *__heap_ptr __attribute__((section(".romglobals")))= 0;
void *_malloc_bottom __attribute__((section(".romglobals")))=0
    , *_malloc_top __attribute__((section(".romglobals")))=0
	, *_malloc_empty __attribute__((section(".romglobals")))=0;

// *****************************
// INTERRUPT STATE
// *****************************


unsigned int __saveint __attribute__((section(".romglobals")))=0;


// Adds a version magic to the globals section, which elf2hp can scan for
// < ibl ; 2005-12-02>

//unsigned int __elf2hp_version_info __attribute__((section(".romglobals")))= (HPGCC_VERSION_MAJOR << 16) | HPGCC_VERSION_MINOR;

// *****************************
// EXIT AND RELATED GLOBALS
// *****************************


unsigned int *__exit_stk_state __attribute__((section(".romglobals")))=NULL;

unsigned int errno __attribute__((section(".romglobals")))=0;

// atexit machinery added by ibl 2005-01-31

ATEXIT_ENTRY *__at_exit_vector __attribute__((section(".romglobals")))= NULL;

// semaphore added by ibl 2005-02-04
int _exit_lock __attribute__((section(".romglobals")))= 0;

// open file list handling ibl 2005-02-06

OPEN_LIST_ENTRY *__open_file_list __attribute__((section(".romglobals")))= NULL;

// *****************************
// VARIABLES USED BY LOADER/CRT0
// *****************************

unsigned int    _heap_base_addr __attribute__((section(".romglobals")))=0;
unsigned int _mmu_table_entries __attribute__((section(".romglobals")))=0;
void *_saturn_cpu __attribute__((section(".romglobals")))=0;


*/


// USER-DEFINED STARTUP CONFIGURATION WORD
unsigned int __startup_options __attribute__((section(".romglobals"))) = 0;

// MASTER GLOBAL STRUCTURES
SYSTEM_GLOBALS *__sg __attribute__((section(".romglobals")))=NULL;
MASTER_GLOBALS *__mg __attribute__((section(".romglobals")))=NULL;



// ************************************
// DEFAULT ROMLIB VERSION CONFIGURATION
// ************************************

ARMCODE_CONFIG(dromlib_version)=MAKE_ROMLIB_VER(ROMLIB_BUILD);




