//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsgetwritetime.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"

void FSGetWriteTime(FS_FILE *file,struct tm *dt)
{

dt->tm_sec=((file->WriteTimeDate&31)<<1);
dt->tm_min=(file->WriteTimeDate>>5)&63;
dt->tm_hour=(file->WriteTimeDate>>11)&31;
dt->tm_mday=(file->WriteTimeDate>>16)&31;
dt->tm_mon=((file->WriteTimeDate>>21)&15) -1;		// month from 0 to 11
dt->tm_year=(file->WriteTimeDate>>25)+80;	// COUNT YEARS FROM 1900 INSTEAD OF 1980
dt->tm_wday=0;
dt->tm_yday=0;
dt->tm_isdst=0;

return;
}
