//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

hpg_font_t *hpg_alloc_font(char *buffer, int count, int height, int advance)
{
    hpg_init();

    hpg_font_t *font = (hpg_font_t *) malloc(sizeof(hpg_font_t));
    if (font == NULL) return NULL;

    font->buffer = buffer;
    font->count = count;
    font->height = height;
    font->advance = advance;

    return font;
}
