//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// ROMLIB CHECKED

// ADDED BY CLAUDIO - JAN 2005
#include <master_globals.h>


void cpu_intoff()
{
    //ARM ints off
    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;

    // CHANGED BY CLAUDIO - APR 2005
    if(!__mg->__saveint) {

    __mg->__saveint=*INTMSK;
    *INTMSK = 0xffffffff; //mask all interrupts

    }
}


// LOW-LEVEL VERSION, RETURN PREVIOUS STATE
// USED BY THE EXCEPTION HANDLERS
unsigned int __cpu_intoff()
{
    //ARM ints off
    unsigned int volatile * INTMSK = (unsigned int*) 0x7100008;
    unsigned int previous=*INTMSK;
    *INTMSK = 0xffffffff; //mask all interrupts
    return previous;
}

