//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// Simple Stream Library for HP49g+


#include "stdio.h"
#include "stdlib.h"
#include <master_globals.h>
#include <fsystem.h>



int fclose(FILE *f)
{
    int r;
    if(f->writecache) {
    	if(f->cacheused>0)
    		r=FSWrite(f->writecache,f->cacheused,f->file);
			free(f->writecache);
	}
    
    r = FSClose(f->file);
    if(r==FS_OK) { free(f); return 0; }
    return EOF;
}



