//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_push.c 415 2007-03-25 18:06:42Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>


BOOL sat3_push(SAT_OBJECT object)
{
if(!object) return FALSE;

if(object&0x60000000) {
object=sat3_copyobject(ALLOC_TEMPOB,object); // CREATE COPY IN TEMPOB AS NEEDED (WHEN OBJECT IS IN C-HEAP OR IN FLASH)
if(!object) return FALSE;
}

if(sat3_getfreeuserob()>=5) {
    // push on stack
    int d1;
    
    d1=sat3_peek(SAT_DSKTOP,5);
    
    d1-=5;
    sat3_poke(d1,object,5);

    sat3_poke(SAT_DSKTOP,d1,5);
    sat3_poke(SAT_AVMEM,sat3_peek(SAT_AVMEM,5)-1,5);
	return TRUE;
    }
	return FALSE;
}


